
package org.hawk.html;

/**
 * This is a placeholder for Option data in an select tag in html
 * @see Select
 * @author msahu
 */
public class Option {

    private String value;

    public Option(){

    }
    public Option(String value, String caption) {
        this.value = value;
        this.caption = caption;
    }
    private String caption;

    public String getCaption() {
        return caption;
    }

    public void setCaption(String caption) {
        this.caption = caption;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Option other = (Option) obj;
        if (this.value != other.value && (this.value == null || !this.value.equals(other.value))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 59 * hash + (this.value != null ? this.value.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "[value={"+getValue()+"} , caption={"+getCaption()+"}]";
    }

    
}
