


package org.hawk.module.lib;

import org.hawk.ds.Stack;
import org.hawk.module.IModule;
import org.hawk.module.annotation.Module;
import org.hawk.module.annotation.SubTask;
import org.hawk.module.script.FunctionScript.FunctionInvocationInfo;
import org.hawk.util.HawkUtil;

/**
 *
 * @version 1.0 10 Jul, 2010
 * @author msahu
 */
@Module(name="SystemModule")
public class SystemModule implements IModule{

    private static final ThreadLocal<Stack<FunctionInvocationInfo>> functionStack = new ThreadLocal<Stack<FunctionInvocationInfo>>();

    static{
        Stack<FunctionInvocationInfo> functionInvocationStack = new Stack<FunctionInvocationInfo>();
        functionStack.set(functionInvocationStack);
    }
    public static ThreadLocal<Stack<FunctionInvocationInfo>> getFunctionStack() {
        return functionStack;
    }

    

    public boolean startUp() {
        throw new UnsupportedOperationException("Not supported yet.");
    }



    public boolean reset() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @SubTask(name="Execute",sequence = 1,ignoreException=false)
    public String execute(Object ... args) throws Exception{

        return HawkUtil.executeProcess((String)args[0])+"";

    }

    @SubTask(name="DumpFunctionStack",sequence = 1,ignoreException=false)
    public String dumpFunctionStack(Object ... args) throws Exception{

        String stackDump = functionStack.get().dump();
        System.out.println(stackDump);
        return stackDump;

    }

}




