

package org.hawk.module.script;


import org.hawk.exception.HawkException;
import org.hawk.module.annotation.CreateScript;
import org.hawk.module.annotation.ScriptPattern;
import java.util.Map;
import java.util.regex.Pattern;
import org.hawk.module.script.enumeration.VarTypeEnum;
import org.hawk.module.script.type.BooleanDataType;
import org.hawk.module.script.type.Variable;
/**
 *
 * @version 1.0 1 May, 2010
 * @author msahu
 * @see IfScript
 */
public class CommentScript extends SingleLineScript{

    /**
     * RegEx Pattern to parse break script
     */
    private  static final Pattern COMMENT_PATTERN=Pattern.compile("\\s*//.*\\s*");


    /**
     * Default CTOR
     */
    public CommentScript(){

    }


    /**
     * Returns the comment script pattern
     * @return returns the comment script pattern
     * @see ScriptPattern
     */
    @ScriptPattern
    public static Pattern getPattern() {
        return COMMENT_PATTERN;
    }
    /**
     * There is nothing to be done except
     * @return
     * @throws org.hawk.exception.HawkException
     */
    @Override
    public Variable execute() throws HawkException {
        BooleanDataType value = new BooleanDataType(true);
        Variable rtn = new Variable(VarTypeEnum.VAR,null,null);
        rtn.setVariableValue(value);
        return rtn;
    }

    /**
     * Nothing to be done here.
     * @param lineCommentMatcherMap
     * @return
     * @see CreateScript
     */
    @CreateScript
    public static CommentScript createScript(Map<Integer,String> lineCommentMatcherMap){

       return  new CommentScript();
    }

    @Override
    public boolean isVariable() {
        return false;
    }
}




