

package org.hawk.module.script.type;

import org.hawk.exception.HawkException;
import org.hawk.util.HawkUtil;

/**
 *
 * @version 1.0 20 Jul, 2010
 * @author msahu
 */
public class StringDataType implements IDataType{

    private String data;
    
    public StringDataType(String data){
        this.data = data;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }

    @Override
    public String toString(){
        return HawkUtil.convertHawkStringToJavaString(this.data);
    }

    public IDataType add(IDataType dataType) throws HawkException {
        if(dataType == null || !(dataType instanceof StringDataType || dataType instanceof DoubleDataType )){
            throw new HawkException("invalid datatype");
        }
       
        StringBuilder sb = new StringBuilder();
        sb.append(HawkUtil.convertHawkStringToJavaString(this.getData()));
        sb.append(HawkUtil.convertHawkStringToJavaString(dataType.toString()));
        
        StringDataType result = new StringDataType(sb.toString());
        
        return result;
    }

    public DoubleDataType subtract(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public DoubleDataType multiply(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public DoubleDataType divide(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public BooleanDataType equalTo(IDataType dataType) throws HawkException {
        if(dataType == null || !(dataType instanceof StringDataType)){
            throw new HawkException("invalid datatype");
        }
        StringDataType thatDateType = (StringDataType)dataType;
        return new BooleanDataType(this.getData().equals(thatDateType.getData()));
    }

    public IDataType copy() throws HawkException {
        IDataType clonedCopy = new StringDataType(this.data);
        return clonedCopy;
    }

   
    public BooleanDataType greaterThan(IDataType dataType) throws HawkException {
        if(dataType == null || !(dataType instanceof StringDataType)){
            throw new HawkException("invalid datatype");
        }
        StringDataType thatDateType = (StringDataType)dataType;
        
        boolean isGreaterThan = this.getData().compareTo(thatDateType.getData())>0;
        BooleanDataType result = new BooleanDataType(isGreaterThan);
        return result;
    }

    public BooleanDataType lessThan(IDataType dataType) throws HawkException {
        if(dataType == null || !(dataType instanceof StringDataType)){
            throw new HawkException("invalid datatype");
        }
        StringDataType thatDateType = (StringDataType)dataType;

        boolean isGreaterThan = this.getData().compareTo(thatDateType.getData()) <0;
        BooleanDataType result = new BooleanDataType(isGreaterThan);
        return result;
    }

    public BooleanDataType greaterThanEqualTo(IDataType dataType) throws HawkException {
         if(dataType == null || !(dataType instanceof StringDataType)){
            throw new HawkException("invalid datatype");
        }
        StringDataType thatDateType = (StringDataType)dataType;

        boolean isGreaterThan = this.getData().compareTo(thatDateType.getData()) >=0;
        BooleanDataType result = new BooleanDataType(isGreaterThan);
        return result;
    }

    public BooleanDataType lessThanEqualTo(IDataType dataType) throws HawkException {
        if(dataType == null || !(dataType instanceof StringDataType)){
            throw new HawkException("invalid datatype");
        }
        StringDataType thatDateType = (StringDataType)dataType;

        boolean isGreaterThan = this.getData().compareTo(thatDateType.getData())<=0;
        BooleanDataType result = new BooleanDataType(isGreaterThan);
        return result;
    }

    public BooleanDataType and(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public BooleanDataType or(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public DoubleDataType modulus(IDataType dataType) throws HawkException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    

}




